-----------------------------------------------------------------------------------------------
-- Client Lua Script for SettlerCACHEButton
-- Copyright (c) NCsoft. All rights reserved
-----------------------------------------------------------------------------------------------
 
require "Window"
--require "PlayerPathLib"
--require "ChatSystemLib"
 
-----------------------------------------------------------------------------------------------
-- SettlerCACHEButton Module Definition
-----------------------------------------------------------------------------------------------
local SettlerCACHEButton = {} 
 
-----------------------------------------------------------------------------------------------
-- Constants
-----------------------------------------------------------------------------------------------
-- e.g. local kiExampleVariableMax = 999
 
-----------------------------------------------------------------------------------------------
-- Initialization
-----------------------------------------------------------------------------------------------
function SettlerCACHEButton:new(o)
    o = o or {}
    setmetatable(o, self)
    self.__index = self 

    -- initialize variables here

    return o
end

function SettlerCACHEButton:Init()
	local bHasConfigureFunction = false
	local strConfigureButtonText = ""
	local tDependencies = {
		-- "UnitOrPackageName",
	}
    Apollo.RegisterAddon(self, bHasConfigureFunction, strConfigureButtonText, tDependencies)
end
 

-----------------------------------------------------------------------------------------------
-- SettlerCACHEButton OnLoad
-----------------------------------------------------------------------------------------------
function SettlerCACHEButton:OnLoad()
    -- load our form file
	self.xmlDoc = XmlDoc.CreateFromFile("SettlerCACHEButton.xml")
	self.xmlDoc:RegisterCallback("OnDocLoaded", self)
end

-----------------------------------------------------------------------------------------------
-- SettlerCACHEButton OnDocLoaded
-----------------------------------------------------------------------------------------------
function SettlerCACHEButton:OnDocLoaded()

	if self.xmlDoc ~= nil and self.xmlDoc:IsLoaded() then
	    self.wndMain = Apollo.LoadForm(self.xmlDoc, "SettlerCACHEButtonForm", nil, self)
		if self.wndMain == nil then
			Apollo.AddAddonErrorText(self, "Could not load the main window for some reason.")
			return
		end
		
	    self.wndMain:Show(false, true)

		-- if the xmlDoc is no longer needed, you should set it to nil
		-- self.xmlDoc = nil
		
		-- Register handlers for events, slash commands and timer, etc.
		-- e.g. Apollo.RegisterEventHandler("KeyDown", "OnKeyDown", self)
		Apollo.RegisterSlashCommand("settlercachebutton", "OnSettlerCACHEButtonOn", self)
		Apollo.RegisterSlashCommand("settlercache", "OnSettlerCACHEButtonOn", self)
		Apollo.RegisterSlashCommand("cachebutton", "OnSettlerCACHEButtonOn", self)
		Apollo.RegisterSlashCommand("cache", "OnSettlerCACHEButtonOn", self)
		
		-- listen to the menu has loaded event so a function can be run here
		Apollo.RegisterEventHandler("InterfaceMenuListHasLoaded", "OnInterfaceMenuListHasLoaded", self)
		
		-- listen to the menu item this addon added, so this addon can be opened
		Apollo.RegisterEventHandler("SettlerCACHEButtonInterfaceList", "OnSettlerCACHEButtonOn", self)

		-- Do additional Addon initialization here
		self.wndMain:FindChild("Text"):SetText("This is a Settler CACHE Scout Quest Helper. If for some reason the path quest tracker glitches and you cannot access the CACHE quest button, this button will do the trick when you are standing on the right location.")
		
	end
end

-----------------------------------------------------------------------------------------------
-- SettlerCACHEButton Functions
-----------------------------------------------------------------------------------------------
-- Define general functions here

-- on SlashCommand "/settlercachebutton", "/settlercache", "/cachebutton", "/cache"
function SettlerCACHEButton:OnSettlerCACHEButtonOn()
	self.wndMain:Invoke() -- show the window
end

function SettlerCACHEButton:OnInterfaceMenuListHasLoaded()
	-- create a menu item which fires an event when pressed
	Event_FireGenericEvent("InterfaceMenuList_NewAddOn", "Settler CACHE Button", {"SettlerCACHEButtonInterfaceList", "", ""})
end


-----------------------------------------------------------------------------------------------
-- SettlerCACHEButtonForm Functions
-----------------------------------------------------------------------------------------------
-- when the CACHE button is clicked
function SettlerCACHEButton:OnCACHE()
	Sound.Play(Sound.PlayUISocialFriendAlert)
	PlayerPathLib.PathAction() -- perform the path action on a CACHE location
end

-- when the Closebutton is clicked
function SettlerCACHEButton:OnClose()
	Sound.Play(Sound.PlayUISocialFriendAlert)
	self.wndMain:Close() -- hide the window
end

function SettlerCACHEButton:OnReloadUI()
	--Sound.Play(Sound.PlayUISocialFriendAlert)
	RequestReloadUI()
end

-----------------------------------------------------------------------------------------------
-- SettlerCACHEButton Instance
-----------------------------------------------------------------------------------------------
local SettlerCACHEButtonInst = SettlerCACHEButton:new()
SettlerCACHEButtonInst:Init()
